<template>
  <v-container>
    <v-dialog v-model="dialog" max-width="75vw" persistent>
      <v-card>
        <v-toolbar flat dense>
          <v-toolbar-title v-if="processType === 'add'">
            {{ formHeader }} </v-toolbar-title
          ><v-toolbar-title v-else>Edit Rule</v-toolbar-title>
          <v-spacer></v-spacer>
        </v-toolbar>
        <v-divider></v-divider>
        <v-container>
          <v-row no-getters align="center" class="flex-nowrap">
            <v-col cols="4" class="align-self-start">
              <div class="mb-4">Classification</div>
              <v-autocomplete
                v-model="selectedCTaxonomies"
                return-object
                clearable
                label="Taxonomy"
                :items="classificationTaxonomies"
                item-text="name"
                dense
                outlined
              ></v-autocomplete>
              <v-autocomplete
                v-model="selectedCType"
                return-object
                clearable
                label="Type"
                :items="classifcationTypes"
                item-text="name"
                dense
                outlined
                no-data-text="Please select a taxonomy first."
              ></v-autocomplete>
              <v-text-field
                v-model="classificationIdentifier"
                label="Identifier"
                dense
                outlined
                :rules="[v => (!v || v.length <= 100) || 'Max 100 characters']"
              >
              </v-text-field>
            </v-col>
            <v-divider vertical></v-divider>
            <v-col
              cols="4"
              class="align-self-start"
            >
              <div class="mb-4">Feed</div>
              <v-autocomplete
                v-model="selectedFProvider"
                return-object
                clearable
                dense
                label="Provider"
                :items="feedProviders"
                item-text="name"
                outlined
              ></v-autocomplete>
              <v-autocomplete
                dense
                v-model="selectedFName"
                return-object
                clearable
                :items="feedNames"
                item-text="name"
                label="Name"
                outlined
                no-data-text="Please select a provider first."
              ></v-autocomplete>
              <v-select
                v-if="store.state.application.netobjectRules.feed.status.enabled"
                dense
                v-model="selectedFStatus"
                label="Status"
                :items="store.state.application.netobjectRules.feed.status.options"
                outlined
              ></v-select>
            </v-col>
            <v-divider vertical></v-divider>
            <v-col cols="4" class="align-self-start">
              <div class="mb-4">Notifications</div>
              <v-autocomplete
                :items="destinations"
                v-model="selectedDestination"
                dense
                return-object
                :hint="
                  `${
                    ruleType !== 'global'
                      ? 'Selecting value is required'
                      : 'Rule suppress'
                  }`
                "
                persistent-hint
                single-line
                :no-data-text="
                  `${ruleType !== 'global' ? 'No Destinations available' : ''}`
                "
                :item-text="getTitle"
                small-chips
                deletable-chips
                :label="`${ruleType !== 'global' ? 'Destination' : ''}`"
                multiple
              >
                <template
                  v-if="selectedDestination"
                  v-slot:message="{ message }"
                >
                  <span
                    :class="{
                      'red--text':
                        !isSuppressed &&
                        !selectedDestination.length &&
                        ruleType !== 'global'
                    }"
                    >{{ message }}</span
                  >
                </template>
                <template v-slot:prepend-inner v-if="isSuppressed">
                  <v-chip
                    small
                    class="orange--text text--darken-2"
                    close
                    @click:close="
                      isSuppressed = false;
                      iconForSuppress = 'mdi-checkbox-blank-outline';
                    "
                    >suppressed</v-chip
                  >
                </template>
                <template v-slot:prepend-item>
                  <v-list-item @click="isSuppressed = !isSuppressed">
                    <v-list-item-action>
                      <v-icon :color="`${isSuppressed ? '#1976d2' : ''}`">
                        {{ iconForSuppress }}
                      </v-icon>
                    </v-list-item-action>
                    <v-list-item-content>
                      <v-list-item-title class="orange--text text--darken-2">
                        Suppressed
                      </v-list-item-title>
                    </v-list-item-content>
                  </v-list-item>
                  <v-divider></v-divider>
                </template>
              </v-autocomplete>
              <span v-if="isSuppressed">
                <v-alert
                    type="warning"
                    dense
                    elevation="2"
                    class="mt-2"
                    border="left"
                >
                Suppression stops selected notifications for anyone, including the for selected contacts.
              </v-alert>
              </span>
              <div class="d-flex flex-column mt-4" v-if="store.state.application.netobjectRules.interval.enabled">
                <span>Interval</span>
                <div class="d-flex align-center">
                  <v-text-field
                    label="length"
                    type="number"
                    min="1"
                    :disabled="selectedIntervalUnit === 'immediate'"
                    v-model="selectedIntervalLength"
                  ></v-text-field>
                  <v-select
                    :items="store.state.application.netobjectRules.interval.units"
                    dense
                    label="Unit"
                    class="mt-6 ml-1"
                    outlined
                    v-model="selectedIntervalUnit"
                  ></v-select>
                </div>
              </div>
            </v-col>
          </v-row>
          <v-divider class="mt-3"></v-divider>
          <v-row no-getters align="center" class="flex-nowrap mt-6">
            <v-col cols="12" class="align-self-start">
              <v-textarea
                  name="commentary"
                  label="Commentary"
                  rows="2"
                  outlined
                  v-model="ruleCommentary"
                  :rules="[v => (!v || v.length <= 255) || 'Max 255 characters']"
                  counter="255"
              ></v-textarea>
            </v-col>
          </v-row>
        </v-container>
        <v-divider></v-divider>
        <v-text-field v-if="loading" loading disabled></v-text-field>
        <div v-if="!isRuleUnique" class="red--text mx-2 mt-1">
          An identical rule already exists, please select different values
        </div>
        <UIAlert
          class="pa-1"
          v-if="hasHttpError"
          v-bind:isSuccessful="false"
          v-bind:message="$store.state.application.httpErrorMessage"
        />
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn
            color="blue darken-1"
            text
            @click="
              $emit('child-object', { closeDialog: true, ruleChanged: false })
            "
            >close</v-btn
          >
          <v-btn
            v-if="processType === 'add'"
            color="blue darken-1"
            text
            :disabled="
              (!selectedDestination.length &&
                !isSuppressed &&
                ruleType !== 'global') ||
                !isRuleUnique ||
                classificationIdentifier > 100 ||
                ruleCommentary.length > 255
            "
            @click="createRule"
            >Create</v-btn
          >
          <v-btn
            v-else
            :disabled="
              (!selectedDestination.length &&
                !isSuppressed &&
                ruleType !== 'global') ||
                !isRuleUnique ||
                classificationIdentifier > 100 ||
                ruleCommentary.length > 255
            "
            color="blue darken-1"
            text
            @click="updateRules"
            >Update</v-btn
          >
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-container>
</template>

<script setup lang="ts">
/*
 * This file is Free Software under GNU Affero General Public License v >= 3.0
 * without warranty, see README.md and license for details.
 *
 * SPDX-License-Identifier: AGPL-3.0-or-later
 *
 * SPDX-FileCopyrightText: 2020 nic.at GmbH <https://nic.at>
 * Software-Engineering: 2020 Intevation GmbH <https://intevation.de>
 *
 * Author(s):
 * 2021, 2022 Fadi Abbud <fadi.abbud@intevation.de>
 */
import { useNotification } from "@/lib/use-notification";
import { useStore } from "@/store";
import { computed, defineAsyncComponent, onMounted, ref, watch } from "vue";
import { HTTP } from "../../lib/http";
import { getTitle } from "@/lib/use-fieldbuilder";
const UIAlert = defineAsyncComponent(() =>
  import("@/components/ui/UIAlert.vue")
);
const props = defineProps({
  processType: String,
  ruleType: String,
  item: Object
});
const emit = defineEmits(["child-object"]);

const dialog = true;
const isSuppressed = ref(false);
const store = useStore();
const { hasRequestError: hasHttpError, resetNotification } = useNotification();
// Selectors
// Classification Taxonomy
const classificationTaxonomies = ref();
const selectedCTaxonomies = ref();
const loading = ref(false);
const getClassificationTaxonomies = () => {
  loading.value = true;
  classificationTaxonomies.value = store.state.application.netobjectRules.classifications;
  loading.value = false;
};
// Classification type
const classifcationTypes = ref();
const selectedCType = ref();
const classificationIdentifier = ref();

// Feed Provider
const feedProviders = ref();
const selectedFProvider = ref();
const getFeedProviders = () => {
  loading.value = true;
  feedProviders.value = store.state.application.netobjectRules.feed.providers;
  loading.value = false;
};
// Feed Name
const feedNames = ref();
const selectedFName = ref();
const selectedFStatus = ref(store.state.application.netobjectRules.feed.status.default);

const orgaID = computed(() => {
  if (store.state.netobject.showOnlyDefaultRules) {
    return store.state.user.selectedNode.node_id;
  } else {
    return store.state.netobject.selectedNO.organisation_id;
  }
});
// Destination
const destinations = ref();
const selectedDestination = ref();
selectedDestination.value = [];
const getDestinations = () => {
  loading.value = true;
  HTTP.get(`/organisations/${orgaID.value}/contacts`)
    .then(response => {
      destinations.value = store.getters["application/getFilteredAbuseContacts"](response.data);

      store
        .dispatch("contact/loadAbuseC", orgaID.value)
        .then(() => {
          destinations.value.unshift(abuseC.value);
          // Set initial values after completely loading contacts and abuse-c
          // as its necessary to know if an abuse_c is available for this organisation.
          if (props.processType === "edit") {
            setInitialValues();
          }
        })
        .catch(() => (hasHttpError.value = true))
        .finally(() => (loading.value = false));
    })
    .catch(() => {
      hasHttpError.value = true;
    })
    .finally(() => {
      loading.value = false;
    });
};

// Interval
const selectedIntervalLength = ref(store.state.application.netobjectRules.interval.default.length);
const selectedIntervalUnit = ref(store.state.application.netobjectRules.interval.default.unit);

// Commentary
const ruleCommentary = ref("");

// Extract the Ids from the selected values as these are important
// for the HTTP requests
const getSelectedValues = () => {
  const selectedValues: {
    [key: string]: string | Array<number> | boolean | number;
  } = {};
  selectedValues.classification_taxonomy_id = selectedCTaxonomies.value
    ? selectedCTaxonomies.value.classification_taxonomy_id
    : -1;
  selectedValues.classification_type_id = selectedCType.value
    ? selectedCType.value.classification_type_id
    : -1;
  selectedValues.feed_provider_id = selectedFProvider.value
    ? selectedFProvider.value.feed_provider_id
    : -1;
  selectedValues.feed_name_id = selectedFName.value
    ? selectedFName.value.feed_name_id
    : -1;
  selectedValues.feed_status = selectedFStatus.value;

  selectedValues.classification_identifier = classificationIdentifier.value;
  selectedValues.commentary = ruleCommentary.value;
  if (props.ruleType !== "global") {
    selectedValues.contacts = selectedDestination.value
      ? selectedDestination.value.map(d => d["contact_id"])
      : [];
    // Set abuse-c if it is selected
    if ((selectedValues.contacts as Array<number>).includes(-1)) {
      selectedValues.abuse_c = true;
      selectedValues.contacts = (selectedValues.contacts as Array<
        number
      >).filter(c => c !== -1);
    } else {
      // Necessary to tell backend to remove abuse-c when it removed by user
      selectedValues.abuse_c = false;
    }
  }
  selectedValues.suppress = isSuppressed.value;
  selectedValues.interval_length = selectedIntervalLength.value;
  selectedValues.interval_unit = selectedIntervalUnit.value;
  return selectedValues;
};
const selectedNetobject = computed(() => {
  return store.state.netobject.selectedNO;
});
// Set the Route according to the type of the rule
// Differentiate between organisaiton and netobeject rules
const route = computed(() => {
  if (props.ruleType === "organisation") {
    return `/organisations/${orgaID.value}`;
  } else {
    return `/organisations/${orgaID.value}
        ${
          selectedNetobject.value.type === "asn"
            ? "/asns/" + selectedNetobject.value.asn_id
            : selectedNetobject.value.type === "network"
            ? "/networks/" + selectedNetobject.value.network_id
            : selectedNetobject.value.type === "domain"
            ? "/fqdns/" + selectedNetobject.value.fqdn_id
            : // Network automatic
              `/ripe_handles/${selectedNetobject.value.parent}/ripe_organisations/
            ${selectedNetobject.value.pivot.organisation_automatic_id}/networks/${selectedNetobject.value.network_automatic_id}`
        }`;
  }
});

// Create Rule
const createRule = () => {
  resetNotification();
  loading.value = true;
  HTTP.post(
    // Check if the created rule is global rule
    props.ruleType === "global" ? "/global_rules" : route.value + "/rules",
    getSelectedValues()
  )
    .then(() => {
      emit("child-object", { closeDialog: true, ruleChanged: true });
    })
    .catch(() => {
      hasHttpError.value = true;
    })
    .finally(() => {
      loading.value = false;
    });
};

// Update rule
const updateRules = () => {
  resetNotification();
  loading.value = true;
  if (props.item) {
    HTTP.put(
      // Build the route according to the rule type
      props.ruleType !== "global"
        ? `${route.value}/rules/${props.item.organisation_rule_id ||
            props.item.asn_rule_id ||
            props.item.network_rule_id ||
            props.item.fqdn_rule_id ||
            props.item.network_automatic_rule_id}`
        : "/global_rules/" + props.item.global_rule_id,
      getSelectedValues()
    )
      .then(() => {
        emit("child-object", { closeDialog: true, ruleChanged: true });
      })
      .catch(() => {
        hasHttpError.value = true;
      })
      .finally(() => {
        loading.value = false;
      });
  }
};

// Set the current values of the Rule
const setInitialValues = () => {
  if (props.item) {
    if (props.item.classification_taxonomy) {
      selectedCTaxonomies.value = props.item.classification_taxonomy;
    }
    if (props.item.classification_type) {
      selectedCType.value = props.item.classification_type;
    }
    if (props.item.feed_name) {
      selectedFName.value = props.item.feed_name;
    }
    if (props.item.feed_provider) {
      selectedFProvider.value = props.item.feed_provider;
    }
    if (props.item.interval_length) {
      selectedIntervalLength.value = props.item.interval_length;
    }
    if (props.item.interval_unit) {
      selectedIntervalUnit.value = props.item.interval_unit;
    }
    if (
      props.ruleType !== "global" &&
      (props.item.contacts.length || props.item.abuse_c)
    ) {
      selectedDestination.value = props.item.contacts || [];
      if (props.item.abuse_c) {
        selectedDestination.value = selectedDestination.value.concat(
          abuseC.value
        );
      }
    }
    selectedFStatus.value = props.item.feed_status;
    classificationIdentifier.value = props.item.classification_identifier ?? "";
    isSuppressed.value = props.item.suppress;
    ruleCommentary.value = props.item.commentary ?? "";
  }
};
// Abuse-c
const abuseC = computed(() => {
  return store.state.contact.abuseC;
});

onMounted(() => {
  getClassificationTaxonomies();
  getFeedProviders();
  // Prevent requesting contacts and abuse-c for global rules
  if (props.ruleType !== "global") {
    getDestinations(); // Getting Abuse-c is done in this function
  }

  if (props.processType === "edit") {
    setInitialValues();
  }

  if (props.processType === "add") {
    // As "status" selector has default value validate if there is a
    // rule that has the same value of this selector
    const item = getSelectedValues();
    validateSelection(item);
  }
});

// Validate the uniqueness of the selections with the already existing rules
const isRuleUnique = ref(true);
const validateSelection = item => {
  isRuleUnique.value = true;
  let rulesToCheck;
  // The selector-part of the rule must be unique
  // per netobject/organisation/global rules
  if (props.ruleType === "organisation") {
    rulesToCheck = store.state.netobject.organisationRules;
    if (props.processType === "edit") {
      // Exclude the current Rule form the uniqueness check
      // in case of rule editing
      rulesToCheck = rulesToCheck.filter(
        r => r.organisation_rule_id !== props.item?.organisation_rule_id
      );
    }
  }
  if (props.ruleType === "netobject") {
    rulesToCheck = store.state.netobject.netobjectRules;
    // Exclude the current rule from compersion by editing rule
    if (props.processType === "edit") {
      // Get the type of the netobject according to the *_rule_id properties
      // to use the right id key in the comparison
      if (Object.keys(rulesToCheck[0]).some(r => r === "fqdn_rule_id")) {
        rulesToCheck = rulesToCheck.filter(
          r => r.fqdn_rule_id !== props.item?.fqdn_rule_id
        );
      } else if (Object.keys(rulesToCheck[0]).some(r => r === "asn_rule_id")) {
        rulesToCheck = rulesToCheck.filter(
          r => r.asn_rule_id !== props.item?.asn_rule_id
        );
      } else if (
        Object.keys(rulesToCheck[0]).some(r => r === "network_rule_id")
      ) {
        rulesToCheck = rulesToCheck.filter(
          r => r.network_rule_id !== props.item?.network_rule_id
        );
      } else if (
        Object.keys(rulesToCheck[0]).some(
          r => r === "network_automatic_rule_id"
        )
      ) {
        rulesToCheck = rulesToCheck.filter(
          r =>
            r.network_automatic_rule_id !==
            props.item?.network_automatic_rule_id
        );
      }
    }
  }
  if (props.ruleType === "global") {
    rulesToCheck = store.state.netobject.globalRules;
    if (props.processType === "edit") {
      rulesToCheck = rulesToCheck.filter(
        r => r.asn_rule_id !== props.item?.asn_rule_id
      );
    }
  }
  rulesToCheck.forEach(r => {
    if (
      r.classification_taxonomy_id === item.classification_taxonomy_id &&
      r.classification_type_id === item.classification_type_id &&
      r.feed_provider_id === item.feed_provider_id &&
      r.feed_name_id === item.feed_name_id &&
      r.feed_status === item.feed_status
    ) {
      isRuleUnique.value = false;
    }
  });
};
watch(
  [
    () => selectedCTaxonomies.value,
    () => selectedCType.value,
    () => selectedFProvider.value,
    () => selectedFName.value,
    () => selectedFStatus.value
  ],
  () => {
    const item = getSelectedValues();
    validateSelection(item);
  }
);
watch(() => selectedCTaxonomies.value, (value) => {
  if (value) {
    if (value.types) {
      classifcationTypes.value = value.types;
    } else {
      classifcationTypes.value = classificationTaxonomies.value.find(
          (taxonomy) => taxonomy.classification_taxonomy_id === value.classification_taxonomy_id
      ).types;
    }
  } else {
    classifcationTypes.value = [];
  }
});
watch(() => selectedFProvider.value, (value) => {
  if (value) {
    if (value.feeds) {
      feedNames.value = value.feeds;
    } else {
      feedNames.value = feedProviders.value.find(
          (provider) => provider.feed_provider_id === value.feed_provider_id
      ).feeds;
    }
  } else {
    feedNames.value = [];
  }
});

// Switch between icons according to the state of "suppress" selection
const iconForSuppress = computed(() => {
  if (isSuppressed.value) {
    //isSuppressed.value = true;
    return "mdi-checkbox-marked";
  } else {
    // isSuppressed.value = false;
    return "mdi-checkbox-blank-outline";
  }
});

// Form the header of the interface according to the type of rule
const formHeader = computed(() => {
  if (props.ruleType === "global") {
    return "Create global rule";
  } else {
    let header = "Create rule for ";
    if (!store.state.netobject.showOnlyDefaultRules) {
      header +=
        props.ruleType === "netobject"
          ? store.state.netobject.selectedNO.netobject
          : // For "networkautomatic" netobjects the orga-name value is the
          // organisation that claimed the RIPE handle.
          store.state.netobject.selectedNO.type === "networkautomatic"
          ? store.state.netobject.selectedNO.organame
          : store.state.netobject.selectedNO.organisation.name;
    } else {
      header += store.state.user.selectedNode.name;
    }
    return header;
  }
});
</script>
